from syntax import *
from opsem import eval_instr

x = AEVar("x")
y = AEVar("y")
zero = AECst(0)
one = AECst(1)
xneg = BELeq(x, zero)
bound_check = ICond(xneg,ISet("x",one),ISkip())
init_y = ISet("y",one)
body = ISeq(ISet("y",AEBop(Bop.MUL,y,x)),ISet("x",AEBop(Bop.ADD,x,AEUop(Uop.OPP,one))))
loop = ILoop(BENeg(BELeq(x,zero)),body)
factorial = ISeq(ISeq(bound_check,init_y),loop)

print(f"prog is\n{factorial}")

env = { "x" : 4 }
envf = eval_instr(env,factorial)

print(f"init is \n{env}")
print(f"result is\n{envf}")
